specification:		{ phylumdeclaration | rwdeclaration | functiondeclaration |
			  includedeclaration | unparsedeclaration | viewdeclaration | storageclassdeclaration } ;

phylumdeclaration:	ID [storage_option] ':' [productionblock] [Ccode] ';' ;

storage_option:		'{' ['!'] ID '}' ;

productionblock:	'list' ID | alternative_list ;

alternative_list:	[alternative_list '|'] ID '(' arguments ')' ;

arguments:		{ID} ; 

Ccode:			'{' [Attributes] [Cbody] '}' ;

Attributes:		[Attributes] ID ID ['=' Cexpression] ';' ;

Cexpression:		/* arbitrary C expression without ';' with '$0' */

includedeclaration:	'%{' {ID} includes '%}' ; /* the tokens are at the beginning of a line */
			/* ID's in {ID} are at the same line as '%{' */

includes:		/* arbitrary text */ ;

rwdeclaration:		outmostpatterns '->' outmostterm ';' ;

outmostpatterns:	outmostpattern [',' outmostpatterns] ;

outmostpattern:		[ID '='] ID ['(' [patterns] ')'] ;

patterns:		pattern [',' patterns] ;

pattern:		ID '=' pattern
|			ID ['(' [patterns] ')']
|			'"' /* any string of characters */ '"'
|			/* a number */
|			'*' | 'default'
;

outmostterm:		ID '(' [terms] ')' ;

term:			ID ['(' [terms] ')'] 
|			'"' /* any string of characters */ '"'
|			/* a number */
;

terms:			term [',' terms] ;

functiondeclaration:	decl_specifiers fn_declarator {declaration} MainCbody ;

decl_specifiers:	[stor_class_specifier] [type_qualifier] ID ;

stor_class_specifier:	'auto' | 'register' | 'static' | 'extern' | 'typedef' ;

type_qualifier:		'const' | 'volatile' ;

fn_declarator:		[pointer] direct_fn_declarator ;

direct_fn_declarator:	ID '(' [fnarguments] ')'
|			ID '(' parameter_type_list ')'
;
/* only one of the declared arguments can have a $ prefix */

fnarguments:		[fnarguments ','] ['$'] ID ;
/* only one of the arguments can have a $ prefix */

parameter_type_list:	parameter_list [',' '...'] ;

parameter_list:		[parameter_list ','] parameter_decl ;

parameter_decl:		decl_specifiers declarator
|			decl_specifiers abstract_declarator
;

declarator:		[pointer] direct_declarator ;

pointer:		'*' {type_qualifier} [pointer] ;

direct_declarator:	['$'] ID
|			'(' pointer direct_declarator ')'
|			direct_declarator '[' [Cexpression] ']'
|			direct_declarator '(' param_type_list ')'
|			direct_declarator '(' [fnarguments] ')'
;
/* only one of the arguments in a function definition can have a $ prefix */

abstract_declarator:	pointer
|			[pointer] direct_abstract_declarator
;

direct_abstract_declarator:	'(' abstract_declarator ')'
|			[direct_abstract_declarator] '[' [Cexpression] ']'
|			[direct_abstract_declarator] '(' [parameter_type_list] ')'
;

declaration:		decl_specifiers	[declarator_list] ;

declarator_list:	[declarator_list ','] declarator ;

MainCbody:		Cbody | with_clause ; /* a with_clause if one the fn arguments has a $ prefix */

Cbody:			'{' Ctext '}' ;

Ctext:			/* arbitrary C text, with $0 through $n, 
			   with_statement and foreach_statement */ ;

foreach_statement:	'foreach' '(' ID ';' ID Cexpression ')' Cbody
|			'foreach' '(' '$' ID ';' ID Cexpression ')' with_clause
|			'foreach' '(' outmostpattern ';' ID Cexpression ')' Cbody
;

with_statement:		'with' '(' Cexpression ')' with_clause ;

with_clause:		'{' {outmostpatterns ':' Cbody} ['default' ':' Cbody] '}' ;

/* with clauses should not have an empty list of patterns */

unparsedeclaration:	outmostpatterns '->' {unparseclause} ';' ;

unparseclause:		'[' viewnames ':' {unparseitem} ']' ;

viewnames:		{ID} ;

unparseitem:		'"' /* any string of characters*/ '"'  [':' ID]
|			['(' ID ')']  ID  {'->' ID}  [':' ID]
|			Cbody
|			'${' {unparseitem} '$}'
;

viewdeclaration:	'%view' viewnames ';' ;

storageclassdeclaration:	'%storageclass' {ID} ';' ;
